require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__LINUX_BPF_H__)) {
    eval 'sub __LINUX_BPF_H__ () {1;}' unless defined(&__LINUX_BPF_H__);
    require 'linux/types.ph';
    require 'linux/bpf_common.ph';
    eval 'sub BPF_ALU64 () {0x7;}' unless defined(&BPF_ALU64);
    eval 'sub BPF_DW () {0x18;}' unless defined(&BPF_DW);
    eval 'sub BPF_XADD () {0xc0;}' unless defined(&BPF_XADD);
    eval 'sub BPF_MOV () {0xb0;}' unless defined(&BPF_MOV);
    eval 'sub BPF_ARSH () {0xc0;}' unless defined(&BPF_ARSH);
    eval 'sub BPF_END () {0xd0;}' unless defined(&BPF_END);
    eval 'sub BPF_TO_LE () {0x;}' unless defined(&BPF_TO_LE);
    eval 'sub BPF_TO_BE () {0x8;}' unless defined(&BPF_TO_BE);
    eval 'sub BPF_FROM_LE () { &BPF_TO_LE;}' unless defined(&BPF_FROM_LE);
    eval 'sub BPF_FROM_BE () { &BPF_TO_BE;}' unless defined(&BPF_FROM_BE);
    eval 'sub BPF_JNE () {0x50;}' unless defined(&BPF_JNE);
    eval 'sub BPF_JSGT () {0x60;}' unless defined(&BPF_JSGT);
    eval 'sub BPF_JSGE () {0x70;}' unless defined(&BPF_JSGE);
    eval 'sub BPF_CALL () {0x80;}' unless defined(&BPF_CALL);
    eval 'sub BPF_EXIT () {0x90;}' unless defined(&BPF_EXIT);
    eval("sub BPF_REG_0 () { 0; }") unless defined(&BPF_REG_0);
    eval("sub BPF_REG_1 () { 1; }") unless defined(&BPF_REG_1);
    eval("sub BPF_REG_2 () { 2; }") unless defined(&BPF_REG_2);
    eval("sub BPF_REG_3 () { 3; }") unless defined(&BPF_REG_3);
    eval("sub BPF_REG_4 () { 4; }") unless defined(&BPF_REG_4);
    eval("sub BPF_REG_5 () { 5; }") unless defined(&BPF_REG_5);
    eval("sub BPF_REG_6 () { 6; }") unless defined(&BPF_REG_6);
    eval("sub BPF_REG_7 () { 7; }") unless defined(&BPF_REG_7);
    eval("sub BPF_REG_8 () { 8; }") unless defined(&BPF_REG_8);
    eval("sub BPF_REG_9 () { 9; }") unless defined(&BPF_REG_9);
    eval("sub BPF_REG_10 () { 10; }") unless defined(&BPF_REG_10);
    eval("sub __MAX_BPF_REG () { 11; }") unless defined(&__MAX_BPF_REG);
    eval 'sub MAX_BPF_REG () { &__MAX_BPF_REG;}' unless defined(&MAX_BPF_REG);
    eval("sub BPF_MAP_CREATE () { 0; }") unless defined(&BPF_MAP_CREATE);
    eval("sub BPF_MAP_LOOKUP_ELEM () { 1; }") unless defined(&BPF_MAP_LOOKUP_ELEM);
    eval("sub BPF_MAP_UPDATE_ELEM () { 2; }") unless defined(&BPF_MAP_UPDATE_ELEM);
    eval("sub BPF_MAP_DELETE_ELEM () { 3; }") unless defined(&BPF_MAP_DELETE_ELEM);
    eval("sub BPF_MAP_GET_NEXT_KEY () { 4; }") unless defined(&BPF_MAP_GET_NEXT_KEY);
    eval("sub BPF_PROG_LOAD () { 5; }") unless defined(&BPF_PROG_LOAD);
    eval("sub BPF_MAP_TYPE_UNSPEC () { 0; }") unless defined(&BPF_MAP_TYPE_UNSPEC);
    eval("sub BPF_MAP_TYPE_HASH () { 1; }") unless defined(&BPF_MAP_TYPE_HASH);
    eval("sub BPF_MAP_TYPE_ARRAY () { 2; }") unless defined(&BPF_MAP_TYPE_ARRAY);
    eval("sub BPF_PROG_TYPE_UNSPEC () { 0; }") unless defined(&BPF_PROG_TYPE_UNSPEC);
    eval("sub BPF_PROG_TYPE_SOCKET_FILTER () { 1; }") unless defined(&BPF_PROG_TYPE_SOCKET_FILTER);
    eval("sub BPF_PROG_TYPE_KPROBE () { 2; }") unless defined(&BPF_PROG_TYPE_KPROBE);
    eval("sub BPF_PROG_TYPE_SCHED_CLS () { 3; }") unless defined(&BPF_PROG_TYPE_SCHED_CLS);
    eval("sub BPF_PROG_TYPE_SCHED_ACT () { 4; }") unless defined(&BPF_PROG_TYPE_SCHED_ACT);
    eval 'sub BPF_PSEUDO_MAP_FD () {1;}' unless defined(&BPF_PSEUDO_MAP_FD);
    eval 'sub BPF_ANY () {0;}' unless defined(&BPF_ANY);
    eval 'sub BPF_NOEXIST () {1;}' unless defined(&BPF_NOEXIST);
    eval 'sub BPF_EXIST () {2;}' unless defined(&BPF_EXIST);
    eval("sub BPF_FUNC_unspec () { 0; }") unless defined(&BPF_FUNC_unspec);
    eval("sub BPF_FUNC_map_lookup_elem () { 1; }") unless defined(&BPF_FUNC_map_lookup_elem);
    eval("sub BPF_FUNC_map_update_elem () { 2; }") unless defined(&BPF_FUNC_map_update_elem);
    eval("sub BPF_FUNC_map_delete_elem () { 3; }") unless defined(&BPF_FUNC_map_delete_elem);
    eval("sub BPF_FUNC_probe_read () { 4; }") unless defined(&BPF_FUNC_probe_read);
    eval("sub BPF_FUNC_ktime_get_ns () { 5; }") unless defined(&BPF_FUNC_ktime_get_ns);
    eval("sub BPF_FUNC_trace_printk () { 6; }") unless defined(&BPF_FUNC_trace_printk);
    eval("sub BPF_FUNC_get_prandom_u32 () { 7; }") unless defined(&BPF_FUNC_get_prandom_u32);
    eval("sub BPF_FUNC_get_smp_processor_id () { 8; }") unless defined(&BPF_FUNC_get_smp_processor_id);
    eval("sub BPF_FUNC_skb_store_bytes () { 9; }") unless defined(&BPF_FUNC_skb_store_bytes);
    eval("sub BPF_FUNC_l3_csum_replace () { 10; }") unless defined(&BPF_FUNC_l3_csum_replace);
    eval("sub BPF_FUNC_l4_csum_replace () { 11; }") unless defined(&BPF_FUNC_l4_csum_replace);
    eval("sub __BPF_FUNC_MAX_ID () { 12; }") unless defined(&__BPF_FUNC_MAX_ID);
}
1;
