require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_FANOTIFY_H)) {
    eval 'sub _LINUX_FANOTIFY_H () {1;}' unless defined(&_LINUX_FANOTIFY_H);
    require 'linux/types.ph';
    eval 'sub FAN_ACCESS () {0x1;}' unless defined(&FAN_ACCESS);
    eval 'sub FAN_MODIFY () {0x2;}' unless defined(&FAN_MODIFY);
    eval 'sub FAN_CLOSE_WRITE () {0x8;}' unless defined(&FAN_CLOSE_WRITE);
    eval 'sub FAN_CLOSE_NOWRITE () {0x10;}' unless defined(&FAN_CLOSE_NOWRITE);
    eval 'sub FAN_OPEN () {0x20;}' unless defined(&FAN_OPEN);
    eval 'sub FAN_Q_OVERFLOW () {0x4000;}' unless defined(&FAN_Q_OVERFLOW);
    eval 'sub FAN_OPEN_PERM () {0x10000;}' unless defined(&FAN_OPEN_PERM);
    eval 'sub FAN_ACCESS_PERM () {0x20000;}' unless defined(&FAN_ACCESS_PERM);
    eval 'sub FAN_ONDIR () {0x40000000;}' unless defined(&FAN_ONDIR);
    eval 'sub FAN_EVENT_ON_CHILD () {0x8000000;}' unless defined(&FAN_EVENT_ON_CHILD);
    eval 'sub FAN_CLOSE () {( &FAN_CLOSE_WRITE |  &FAN_CLOSE_NOWRITE);}' unless defined(&FAN_CLOSE);
    eval 'sub FAN_CLOEXEC () {0x1;}' unless defined(&FAN_CLOEXEC);
    eval 'sub FAN_NONBLOCK () {0x2;}' unless defined(&FAN_NONBLOCK);
    eval 'sub FAN_CLASS_NOTIF () {0x;}' unless defined(&FAN_CLASS_NOTIF);
    eval 'sub FAN_CLASS_CONTENT () {0x4;}' unless defined(&FAN_CLASS_CONTENT);
    eval 'sub FAN_CLASS_PRE_CONTENT () {0x8;}' unless defined(&FAN_CLASS_PRE_CONTENT);
    eval 'sub FAN_ALL_CLASS_BITS () {( &FAN_CLASS_NOTIF |  &FAN_CLASS_CONTENT |  &FAN_CLASS_PRE_CONTENT);}' unless defined(&FAN_ALL_CLASS_BITS);
    eval 'sub FAN_UNLIMITED_QUEUE () {0x10;}' unless defined(&FAN_UNLIMITED_QUEUE);
    eval 'sub FAN_UNLIMITED_MARKS () {0x20;}' unless defined(&FAN_UNLIMITED_MARKS);
    eval 'sub FAN_ALL_INIT_FLAGS () {( &FAN_CLOEXEC |  &FAN_NONBLOCK |  &FAN_ALL_CLASS_BITS |  &FAN_UNLIMITED_QUEUE |  &FAN_UNLIMITED_MARKS);}' unless defined(&FAN_ALL_INIT_FLAGS);
    eval 'sub FAN_MARK_ADD () {0x1;}' unless defined(&FAN_MARK_ADD);
    eval 'sub FAN_MARK_REMOVE () {0x2;}' unless defined(&FAN_MARK_REMOVE);
    eval 'sub FAN_MARK_DONT_FOLLOW () {0x4;}' unless defined(&FAN_MARK_DONT_FOLLOW);
    eval 'sub FAN_MARK_ONLYDIR () {0x8;}' unless defined(&FAN_MARK_ONLYDIR);
    eval 'sub FAN_MARK_MOUNT () {0x10;}' unless defined(&FAN_MARK_MOUNT);
    eval 'sub FAN_MARK_IGNORED_MASK () {0x20;}' unless defined(&FAN_MARK_IGNORED_MASK);
    eval 'sub FAN_MARK_IGNORED_SURV_MODIFY () {0x40;}' unless defined(&FAN_MARK_IGNORED_SURV_MODIFY);
    eval 'sub FAN_MARK_FLUSH () {0x80;}' unless defined(&FAN_MARK_FLUSH);
    eval 'sub FAN_ALL_MARK_FLAGS () {( &FAN_MARK_ADD |  &FAN_MARK_REMOVE |  &FAN_MARK_DONT_FOLLOW |  &FAN_MARK_ONLYDIR |  &FAN_MARK_MOUNT |  &FAN_MARK_IGNORED_MASK |  &FAN_MARK_IGNORED_SURV_MODIFY |  &FAN_MARK_FLUSH);}' unless defined(&FAN_ALL_MARK_FLAGS);
    eval 'sub FAN_ALL_EVENTS () {( &FAN_ACCESS |  &FAN_MODIFY |  &FAN_CLOSE |  &FAN_OPEN);}' unless defined(&FAN_ALL_EVENTS);
    eval 'sub FAN_ALL_PERM_EVENTS () {( &FAN_OPEN_PERM |  &FAN_ACCESS_PERM);}' unless defined(&FAN_ALL_PERM_EVENTS);
    eval 'sub FAN_ALL_OUTGOING_EVENTS () {( &FAN_ALL_EVENTS |  &FAN_ALL_PERM_EVENTS |  &FAN_Q_OVERFLOW);}' unless defined(&FAN_ALL_OUTGOING_EVENTS);
    eval 'sub FANOTIFY_METADATA_VERSION () {3;}' unless defined(&FANOTIFY_METADATA_VERSION);
    eval 'sub FAN_ALLOW () {0x1;}' unless defined(&FAN_ALLOW);
    eval 'sub FAN_DENY () {0x2;}' unless defined(&FAN_DENY);
    eval 'sub FAN_NOFD () {-1;}' unless defined(&FAN_NOFD);
    eval 'sub FAN_EVENT_METADATA_LEN () {($sizeof{\'struct fanotify_event_metadata\'});}' unless defined(&FAN_EVENT_METADATA_LEN);
    eval 'sub FAN_EVENT_NEXT {
        my($meta, $len) = @_;
	    eval q((($len) -= ($meta)-> &event_len, ((($meta)) + ($meta)-> &event_len)));
    }' unless defined(&FAN_EVENT_NEXT);
    eval 'sub FAN_EVENT_OK {
        my($meta, $len) = @_;
	    eval q(( >=  &FAN_EVENT_METADATA_LEN  && -> &event_len >=  &FAN_EVENT_METADATA_LEN  && -> &event_len <= ($len)));
    }' unless defined(&FAN_EVENT_OK);
}
1;
