require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MD_P_H)) {
    eval 'sub _MD_P_H () {1;}' unless defined(&_MD_P_H);
    require 'linux/types.ph';
    require 'asm/byteorder.ph';
    eval 'sub MD_RESERVED_BYTES () {(64* 1024);}' unless defined(&MD_RESERVED_BYTES);
    eval 'sub MD_RESERVED_SECTORS () {( &MD_RESERVED_BYTES / 512);}' unless defined(&MD_RESERVED_SECTORS);
    eval 'sub MD_NEW_SIZE_SECTORS {
        my($x) = @_;
	    eval q((($x & ~( &MD_RESERVED_SECTORS - 1)) -  &MD_RESERVED_SECTORS));
    }' unless defined(&MD_NEW_SIZE_SECTORS);
    eval 'sub MD_SB_BYTES () {4096;}' unless defined(&MD_SB_BYTES);
    eval 'sub MD_SB_WORDS () {( &MD_SB_BYTES / 4);}' unless defined(&MD_SB_WORDS);
    eval 'sub MD_SB_SECTORS () {( &MD_SB_BYTES / 512);}' unless defined(&MD_SB_SECTORS);
    eval 'sub MD_SB_GENERIC_OFFSET () {0;}' unless defined(&MD_SB_GENERIC_OFFSET);
    eval 'sub MD_SB_PERSONALITY_OFFSET () {64;}' unless defined(&MD_SB_PERSONALITY_OFFSET);
    eval 'sub MD_SB_DISKS_OFFSET () {128;}' unless defined(&MD_SB_DISKS_OFFSET);
    eval 'sub MD_SB_DESCRIPTOR_OFFSET () {992;}' unless defined(&MD_SB_DESCRIPTOR_OFFSET);
    eval 'sub MD_SB_GENERIC_CONSTANT_WORDS () {32;}' unless defined(&MD_SB_GENERIC_CONSTANT_WORDS);
    eval 'sub MD_SB_GENERIC_STATE_WORDS () {32;}' unless defined(&MD_SB_GENERIC_STATE_WORDS);
    eval 'sub MD_SB_GENERIC_WORDS () {( &MD_SB_GENERIC_CONSTANT_WORDS +  &MD_SB_GENERIC_STATE_WORDS);}' unless defined(&MD_SB_GENERIC_WORDS);
    eval 'sub MD_SB_PERSONALITY_WORDS () {64;}' unless defined(&MD_SB_PERSONALITY_WORDS);
    eval 'sub MD_SB_DESCRIPTOR_WORDS () {32;}' unless defined(&MD_SB_DESCRIPTOR_WORDS);
    eval 'sub MD_SB_DISKS () {27;}' unless defined(&MD_SB_DISKS);
    eval 'sub MD_SB_DISKS_WORDS () {( &MD_SB_DISKS* &MD_SB_DESCRIPTOR_WORDS);}' unless defined(&MD_SB_DISKS_WORDS);
    eval 'sub MD_SB_RESERVED_WORDS () {(1024-  &MD_SB_GENERIC_WORDS -  &MD_SB_PERSONALITY_WORDS -  &MD_SB_DISKS_WORDS -  &MD_SB_DESCRIPTOR_WORDS);}' unless defined(&MD_SB_RESERVED_WORDS);
    eval 'sub MD_SB_EQUAL_WORDS () {( &MD_SB_GENERIC_WORDS +  &MD_SB_PERSONALITY_WORDS +  &MD_SB_DISKS_WORDS);}' unless defined(&MD_SB_EQUAL_WORDS);
    eval 'sub MD_DISK_FAULTY () {0;}' unless defined(&MD_DISK_FAULTY);
    eval 'sub MD_DISK_ACTIVE () {1;}' unless defined(&MD_DISK_ACTIVE);
    eval 'sub MD_DISK_SYNC () {2;}' unless defined(&MD_DISK_SYNC);
    eval 'sub MD_DISK_REMOVED () {3;}' unless defined(&MD_DISK_REMOVED);
    eval 'sub MD_DISK_CLUSTER_ADD () {4;}' unless defined(&MD_DISK_CLUSTER_ADD);
    eval 'sub MD_DISK_CANDIDATE () {5;}' unless defined(&MD_DISK_CANDIDATE);
    eval 'sub MD_DISK_WRITEMOSTLY () {9;}' unless defined(&MD_DISK_WRITEMOSTLY);
    eval 'sub MD_SB_MAGIC () {0xa92b4efc;}' unless defined(&MD_SB_MAGIC);
    eval 'sub MD_SB_CLEAN () {0;}' unless defined(&MD_SB_CLEAN);
    eval 'sub MD_SB_ERRORS () {1;}' unless defined(&MD_SB_ERRORS);
    eval 'sub MD_SB_CLUSTERED () {5;}' unless defined(&MD_SB_CLUSTERED);
    eval 'sub MD_SB_BITMAP_PRESENT () {8;}' unless defined(&MD_SB_BITMAP_PRESENT);
    if(defined(&__BYTE_ORDER) ? (defined(&__BYTE_ORDER) ? &__BYTE_ORDER : undef) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : undef) : defined(&__BIG_ENDIAN)) {
    }
 elsif(defined(&__BYTE_ORDER) ? (defined(&__BYTE_ORDER) ? &__BYTE_ORDER : undef) == (defined(&__LITTLE_ENDIAN) ? &__LITTLE_ENDIAN : undef) : defined(&__LITTLE_ENDIAN)) {
    } else {
	die("unspecified\ endianness");
    }
    eval 'sub md_event {
        my($sb) = @_;
	    eval q({  &__u64  &ev =  ($sb->{events_hi}); ( &ev<<32)|  ($sb->{events_lo}); });
    }' unless defined(&md_event);
    eval 'sub MD_SUPERBLOCK_1_TIME_SEC_MASK () {((1<<40) - 1);}' unless defined(&MD_SUPERBLOCK_1_TIME_SEC_MASK);
    eval 'sub WriteMostly1 () {1;}' unless defined(&WriteMostly1);
    eval 'sub MD_FEATURE_BITMAP_OFFSET () {1;}' unless defined(&MD_FEATURE_BITMAP_OFFSET);
    eval 'sub MD_FEATURE_RECOVERY_OFFSET () {2;}' unless defined(&MD_FEATURE_RECOVERY_OFFSET);
    eval 'sub MD_FEATURE_RESHAPE_ACTIVE () {4;}' unless defined(&MD_FEATURE_RESHAPE_ACTIVE);
    eval 'sub MD_FEATURE_BAD_BLOCKS () {8;}' unless defined(&MD_FEATURE_BAD_BLOCKS);
    eval 'sub MD_FEATURE_REPLACEMENT () {16;}' unless defined(&MD_FEATURE_REPLACEMENT);
    eval 'sub MD_FEATURE_RESHAPE_BACKWARDS () {32;}' unless defined(&MD_FEATURE_RESHAPE_BACKWARDS);
    eval 'sub MD_FEATURE_NEW_OFFSET () {64;}' unless defined(&MD_FEATURE_NEW_OFFSET);
    eval 'sub MD_FEATURE_RECOVERY_BITMAP () {128;}' unless defined(&MD_FEATURE_RECOVERY_BITMAP);
    eval 'sub MD_FEATURE_ALL () {( &MD_FEATURE_BITMAP_OFFSET | &MD_FEATURE_RECOVERY_OFFSET | &MD_FEATURE_RESHAPE_ACTIVE | &MD_FEATURE_BAD_BLOCKS | &MD_FEATURE_REPLACEMENT | &MD_FEATURE_RESHAPE_BACKWARDS | &MD_FEATURE_NEW_OFFSET | &MD_FEATURE_RECOVERY_BITMAP );}' unless defined(&MD_FEATURE_ALL);
}
1;
